Deluge

De Wiki
Ir para: navegação, pesquisa

Deluge

Sobre

Este é um programa para acessar realizar o download de torrent. O interessante é que podemos configurá-lo para funcionar como um cliente que pode ser executado no console do Linux. Outra vantagen é que ele é leve o suficiente para ser executado no Raspberry Pi.

Debian Squeeze 7.0

Instalando os Pacotes Necessários

A instalação do Deluge é simples, basta baixar o seu pacote:

# apt-get install deluged deluge-console

Isso vai baixar o programa principal e o seu modo para acesso por console.

Configurações Básicas

Assim que os programas foram instalados, o próximo passo é iniciar o serviço com o usuário que vai gerenciá-lo (recomendo fortemente que seja um usuário não privilegiado).

Vou usar o meu usuário padrão condector. Agora, com o usuário desejado, inicialize o serviço:

$ deluged

em seguida, mate o processo:

$ pkill deluged

Isso vai criar o arquivo de configuração padrão na conta do usuário. Vamos salvar a configuração antiga e criar uma nova:

$ cp ~/.config/deluge/auth ~/.config/deluge/auth.old

Agora vamos criar o usuário e senha de acesso ao serviço. O arquivo de configuração segue a seguinte convenção:

usuário:senha:nível

O nível máximo é 10 (permite acesso total e administrativo ao serviço). Vamos criar um usuário:

$ vim ~/.config/deluge/auth
pi:senhaforte123:10

Agora que já cadastramos o nosso novo usuário, vamos iniciar novamente o serviço e acessar o console:

$ deluged

Em seguida, abra o console do Deluge:

$ deluge-console

Você vai ver uma tela preta com um rodapé em azul com letras amarelas. No local que você pode editar digite o seguite:

config -s allow_remote True
config allow_remote
exit

A janela vai ficar similar a essa:

Deluge-console.jpg

Vamos matar novamente o processo e prepará-lo para inicialização automática.

$ pkill deluged

Inicialização Automática

Para que o Deluge inicialize automaticamente, vamos criar dois arquivos importantes. O primeiro é o arquivo de configurações padrão:

# vim /etc/default/deluge-daemon 
# Configuration for /etc/init.d/deluge-daemon

# The init.d script will only run if this variable non-empty.
DELUGED_USER="pi"             # !!!CHANGE THIS!!!!

# Should we run at startup?
RUN_AT_STARTUP="YES"

Um detalhe muito importante é que nesse arquivo devemos colocar o usuário que configuramos anteriormente:

# vim /etc/default/deluge-daemon 
...
DELUGED_USER="admin"
...

Em seguida, devemos ativar o script na inicialização:

# chmod 755 /etc/default/deluge-daemon
# update-rc.d deluge-daemon defaults

Agora, é necessário criar o script de inicialização de fato:

# vim /etc/init.d/deluge-daemon
#!/bin/sh
### BEGIN INIT INFO
# Provides:          deluge-daemon
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Should-Start:      $network
# Should-Stop:       $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Daemonized version of deluge and webui.
# Description:       Starts the deluge daemon with the user specified in
#                    /etc/default/deluge-daemon.
### END INIT INFO  

# Author: Adolfo R. Brandes 

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="Deluge Daemon"
NAME1="deluged"
NAME2="deluge"
DAEMON1=/usr/bin/deluged
DAEMON1_ARGS="-d"             # Consult `man deluged` for more options
DAEMON2=/usr/bin/deluge-web
DAEMON2_ARGS=""               # Consult `man deluge-web` for more options
PIDFILE1=/var/run/$NAME1.pid
PIDFILE2=/var/run/$NAME2.pid
UMASK=022                     # Change this to 0 if running deluged as its own user
PKGNAME=deluge-daemon
SCRIPTNAME=/etc/init.d/$PKGNAME 

# Exit if the package is not installed
[ -x "$DAEMON1" -a -x "$DAEMON2" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$PKGNAME ] && . /etc/default/$PKGNAME 

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions 

if [ -z "$RUN_AT_STARTUP" -o "$RUN_AT_STARTUP" != "YES" ]
then
   log_warning_msg "Not starting $PKGNAME, edit /etc/default/$PKGNAME to start it."
   exit 0
fi 

if [ -z "$DELUGED_USER" ]
then
    log_warning_msg "Not starting $PKGNAME, DELUGED_USER not set in  /etc/default/$PKGNAME."
    exit 0
fi

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --exec $DAEMON1  \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL1="$?"
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --exec $DAEMON2  \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 1 

   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --make-pidfile  --exec $DAEMON1 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON1_ARGS
   RETVAL1="$?"
        sleep 2
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --make-pidfile  --exec $DAEMON2 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON2_ARGS
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred 

   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER -- pidfile $PIDFILE2
   RETVAL2="$?"
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER -- pidfile $PIDFILE1 
   RETVAL1="$?"
   [ "$RETVAL1" = "2" -o "$RETVAL2" = "2" ] && return 2

   rm -f $PIDFILE1 $PIDFILE2

   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] && return 0 || return 1
}

case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME1"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME1"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  restart|force-reload)
   log_daemon_msg "Restarting $DESC" "$NAME1"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

Ajustar as permissões:

# chmod 755 /etc/init.d/deluge-daemon
# update-rc.d deluge-daemon defaults

Lembrando que esse script de inicialização precisa que a configuração do Cliente Web também esteja configurada. O pacote dos arquivos acima estão aqui.

Configuração do Cliente Desktop

Para que o cliente Desktop funcione (acessando o seu servidor remoto), o primeiro passo é mudar nas Preferências->Interface o modo para Clássico (Classic Mode):

Classic-mode.jpg

Agora clique em OK e reinicia o cliente Desktop. Ao iniciá-lo você vai ver uma janela para adicionar Hosts remotos. Adicione um novo Host com o endereço IP do seu servidor com Deluge e com os usuário e senha que configuramos anteriormente:

Add-host.jpg

Em seguida, vamos ver que o Estado (Status) do nosso servidor remoto (incluindo a versão do Deluge em execução) está funcionando. Basta clicar em Connect.

Server-remote.jpg

Quando a conexão for estabelecida, você verá a janela do Desktop:

Deluge-gui.jpg

Pronto, temos nosso cliente Desktop funcionando com nosso servidor Deluge remoto.

Configuração do Cliente Web

A configuração do cliente web é bem mais rápida, mas temos bem menos funcionalidades. Contudo, é bem útil quando precisamos enviar um arquivo para download remotamente e não temos acesso ao cliente.

Para instalar o cliente web devemos instalar os seguintes serviços:

# apt-get install python-mako deluge-web

Isso vai instalar o cliente web que é acessível na porta 8112 do seu servidor remoto. Agora vamos inicializar todos os serviços necessários:

# /etc/init.d/deluge-daemon start


Pronto, basta apontar o seu navegador web para o endereço do seu servidor:

Web-url.png

Como você está fazendo o primeiro acesso, ele pede para que você modifique a senha de acesso (a senha padrão é deluge):

First-access-gui.png

E será aberta a janela de configuração para troca de senha:

Web-gui-changepass.png

Pronto, sua interface Gui e o daemon para acesso remoto com cliente Desktop estão prontos.

Uma sugestão é o aplicativo para Android é o Transdroid.

Referências

[1] HowtoGeek]


--Brivaldo (discussão) 15h10min de 24 de julho de 2015 (AMT)